/* Copyright (C) 2011, 2012, 2013 by Bundesanstalt für Gewässerkunde
 * Software engineering by Intevation GmbH
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */

package org.dive4elements.river.importer;

import java.util.List;

import org.apache.log4j.Logger;
import org.dive4elements.river.model.LocationSystem;
import org.hibernate.Query;
import org.hibernate.Session;


public class ImportLocationSystem {

    private static final Logger log =
            Logger.getLogger(ImportLocationSystem.class);


    protected String name;
    protected String description;

    protected LocationSystem peer;


    public ImportLocationSystem(final String name, final String description) {
        this.name        = name;
        this.description = description;
    }

    public void storeDependencies() {
        log.info("store LocationSystem '" + this.name + "'");
        final LocationSystem ls = getPeer();

        final Session session = ImporterSession.getInstance().getDatabaseSession();
        session.flush();
    }

    public LocationSystem getPeer() {
        if (this.peer != null)
            return this.peer;
        final Session session = ImporterSession.getInstance().getDatabaseSession();
        final Query query = session.createQuery("FROM LocationSystem WHERE (trim(name)=:name) AND (trim(description)=:description)");
        query.setParameter("name", this.name);
        query.setParameter("description", this.description);
        final List<LocationSystem> lss = query.list();
        if (lss.isEmpty()) {
            this.peer = new LocationSystem(this.name, this.description);
            session.save(this.peer);
        } else {
            this.peer = lss.get(0);
        }
        return this.peer;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
